{smcl}
{* 2017-09-11 Scott Long}{...}
{title:Title}

{p2colset 5 16 16 1}{...}
{p2col:{cmd:makecd} {hline 2}}Create command to changes the working directory
and set up a project environment{p_end}
{p2colreset}{...}

{title:General syntax}

{p 4 14 2}
{cmd:makecd }[{cmd:cd}]{it:project} [{cmd:,}
{opt n:ote(string)}
{opt auto:run(command-name)}
{opt data(path-name)}
{opt data2(path-name)}
{opt url(web-address)}
{opt user(string)}
{opt nos:lash} 
{opt det:ails}
{opt replace}]
{p_end}

{title:Options}
{p2colset 5 22 23 0}
{synopt:{opt n:ote(string)}} describes the command being created.
{p_end}
{p2colset 5 22 23 0}
{synopt:{opt auto:run(command)}} is command to be run by
{cmd:cd}{it:project}.
{p_end}
{p2colset 5 22 23 0}
{synopt:{opt data(path-name)}} is a path for datasets; saved
in global macro {cmd:S_cddata}. 
{p_end}
{p2colset 5 22 23 0}
{synopt:{opt data2(path-name)}} is a second data path; saved
in global macro {cmd:S_cddata2}. 
{p_end}
{p2colset 5 22 23 0}
{synopt:{opt url(web-address)}} is web address; saved 
in global macro {cmd:S_cdurl}.
{p_end}
{p2colset 5 22 23 0}
{synopt:{opt user(string)}} is a any string; stored
in global macro {cmd:S_cduser}.
{p_end}
{p2colset 5 22 23 0}
{synopt:{opt noslash}} prevents slash from being added to end of paths and URLs.
{p_end}
{p2colset 5 22 23 0}
{synopt:{opt det:ails}} displays globals macros created by {cmd:cd}{it:project}
commands.
{p_end}
{p2colset 5 22 23 0}
{synopt:{opt replace}} replace ado file if it exists.
{p_end}

{pstd}
Commands names must start with {cmd:cd}. You can enter
the name as {it:cdproject} or as {it:project}; 
if needed, {cmd:cd} is added to the name.
Since names of global macros begin with
{cmd:S_} they are not dropped by {cmd:clear all} or
{cmd:macro drop _all}. To drop then, run {cmd:macro drop }{it:global-name}.

{title:Overview}

{pstd}
{cmd:makecd} creates (i.e., makes) an ado file {cmd:cd}{it:project}{cmd:.ado}
that changes your working directory, creates global macros, and 
automatically runs a command specified by {cmd:auto()}.
The {cmd:cd}{it:project}{cmd:.ado} commands are saved in the PERSONAL directory.

{pstd}
By creating multiple
{cmd:cd}{it:project} commands, you can easily
have different working directories for each
project with optional data locations for each project. The 
{cmd:listcd} command lists your {cmd:cd}{it:project} commands along with
the the working directory it sets or the note 
added as an option to {cmd:makecd}.
The {cmd:dropcd} command deletes selected {cmd:cd}{it:project} commands
from PERSONAL.

{title:Creating and using a cdproject command}

{pstd}
{cmd:1.} Change to a working directory. For example,

{p 8 18 2}{cmd:. cd d:/paper/work}{p_end}
{p 8 18 2}{cmd:d:/paper/work}{p_end}

{pstd}
{cmd:2.} Decide on a project name associated with the working directory,
such as {cmd:paper} and create 
the command {cmd:cd}{it:project} command using
{cmd:makecd}. For example,

{p 8 18 2}{cmd:. makecd paper}  {p_end}
{p 8 18 2}command {bf:cdpaper} saved in your PERSONAL directory{p_end}

{pstd}
Since the command is saved in PERSONAL, Stata will find it
when you run the command from any working directory:

{pstd}
{cmd:3.}To change your working directory, run your {cmd:cd}{it:project}
command which will echo the path of the working directory. For example,

{p 8 18 2}{cmd:. cdpaper}{p_end}
{p 8 18 2}{bf:d:/paper/work}{p_end}

{title:Using globals for datasets not in the working directory}

{pstd}
By default, {cmd:use} loads a dataset from the working
directory and {cmd:save} saves a dataset to the working directory.
To load a dataset from the path specified by the {cmd:data()} option
in {cmd:makecd},

{p 8 18 2} {cmd:use "${S_cddata}mydata", clear} {p_end}

{pstd}
To load a dataset from the directory specified by the {cmd:data2()} option,

{p 8 18 2} {cmd:use "${S_cddata2}mydata", clear} {p_end}

{pstd}
You can save datasets to the data directorys with command such as

{p 8 18 2} {cmd:save "${S_cddata}mydata", clear} {p_end}
{p 8 18 2} {cmd:save "${S_cddata2}mydata", clear} {p_end}

{pstd}
To load a dataset from the URL specified by the {cmd:url()} option,

{p 8 18 2} {cmd:use "${S_cdurl}mydata", clear} {p_end}

{title:Automatically running a command for each project}

{pstd}
The {opt auto:run(command)} option lets you specify a command that is run
by {cmd:cd}{it:project} after it changes the working directory and creates
global macros.
Thc command could be something like {cmd:auto(dir *.dta)}
or {cmd:auto(do project-setup)}.

{title:Controlling the starting working directory}

{pstd}
You can create the command {cmd:cdstart} with {cmd:makecd} and 
add {cmd:cdstart} to your {cmd:profile.do} to make the directory
set by {cmd:cmdstart} the starting directory in Stata.
You can replace the existing {cmd:cdstart} to have Stata begin in 
a different directory. 

{title:Globals}

{pstd}
{cmd:cd}{it:project} commands create these globals:

{p2colset 8 19 12 0}
{synopt:{opt S_cdcmd}} name of {cmd:cd}{it:project} command.
{p_end}
{p2colset 8 19 12 0}
{synopt:{opt S_cdauto}} command to be run by {cmd:cd}{it:project}.
{p_end}
{p2colset 8 19 12 0}
{synopt:{opt S_cddata}} data directory path.
{p_end}
{p2colset 8 19 12 0}
{synopt:{opt S_cddata2}} second data directory path.
{p_end}
{p2colset 8 19 12 0}
{synopt:{opt S_cdurl}} web address.
{p_end}
{p2colset 8 19 12 0}
{synopt:{opt S_cduser}} any string.
{p_end}
{p2colset 8 19 12 0}
{synopt:{opt S_cdwd}} working directory set by {cmd:cd}{it:project}.
{p_end}

{title:Citation}

{p 4 4 10}
J. Scott Long. 2017.
{it:A Workflow for Changing Working Directories and Managing Projects.}
{browse "http://www.indiana.edu/~jslsoc/"}
{p_end}
